/*
* Copyright 2020 Kumori systems S.L.
*
* Licensed under the EUPL, Version 1.2 or – as soon they
* will be approved by the European Commission - subsequent
* versions of the EUPL (the "Licence");
* You may not use this work except in compliance with the
* Licence.
* You may obtain a copy of the Licence at:
*
* https://joinup.ec.europa.eu/software/page/eupl
*
* Unless required by applicable law or agreed to in
* writing, software distributed under the Licence is
* distributed on an "AS IS" basis,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
* express or implied.
* See the Licence for the specific language governing
* permissions and limitations under the Licence.
 */
// Code generated by client-gen. DO NOT EDIT.

package v1beta2

import (
	"context"
	"time"

	v1beta2 "gitlab.com/kumori-systems/community/libraries/clusterapi-client-go/pkg/apis_aws/aws/v1beta2"
	scheme "gitlab.com/kumori-systems/community/libraries/clusterapi-client-go/pkg/generated-aws/clientset/versioned/scheme"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	rest "k8s.io/client-go/rest"
)

// AWSClusterStaticIdentitiesGetter has a method to return a AWSClusterStaticIdentityInterface.
// A group's client should implement this interface.
type AWSClusterStaticIdentitiesGetter interface {
	AWSClusterStaticIdentities() AWSClusterStaticIdentityInterface
}

// AWSClusterStaticIdentityInterface has methods to work with AWSClusterStaticIdentity resources.
type AWSClusterStaticIdentityInterface interface {
	Create(ctx context.Context, aWSClusterStaticIdentity *v1beta2.AWSClusterStaticIdentity, opts v1.CreateOptions) (*v1beta2.AWSClusterStaticIdentity, error)
	Update(ctx context.Context, aWSClusterStaticIdentity *v1beta2.AWSClusterStaticIdentity, opts v1.UpdateOptions) (*v1beta2.AWSClusterStaticIdentity, error)
	Delete(ctx context.Context, name string, opts v1.DeleteOptions) error
	DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error
	Get(ctx context.Context, name string, opts v1.GetOptions) (*v1beta2.AWSClusterStaticIdentity, error)
	List(ctx context.Context, opts v1.ListOptions) (*v1beta2.AWSClusterStaticIdentityList, error)
	Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error)
	Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1beta2.AWSClusterStaticIdentity, err error)
	AWSClusterStaticIdentityExpansion
}

// aWSClusterStaticIdentities implements AWSClusterStaticIdentityInterface
type aWSClusterStaticIdentities struct {
	client rest.Interface
}

// newAWSClusterStaticIdentities returns a AWSClusterStaticIdentities
func newAWSClusterStaticIdentities(c *InfrastructureV1beta2Client) *aWSClusterStaticIdentities {
	return &aWSClusterStaticIdentities{
		client: c.RESTClient(),
	}
}

// Get takes name of the aWSClusterStaticIdentity, and returns the corresponding aWSClusterStaticIdentity object, and an error if there is any.
func (c *aWSClusterStaticIdentities) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1beta2.AWSClusterStaticIdentity, err error) {
	result = &v1beta2.AWSClusterStaticIdentity{}
	err = c.client.Get().
		Resource("awsclusterstaticidentities").
		Name(name).
		VersionedParams(&options, scheme.ParameterCodec).
		Do(ctx).
		Into(result)
	return
}

// List takes label and field selectors, and returns the list of AWSClusterStaticIdentities that match those selectors.
func (c *aWSClusterStaticIdentities) List(ctx context.Context, opts v1.ListOptions) (result *v1beta2.AWSClusterStaticIdentityList, err error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	result = &v1beta2.AWSClusterStaticIdentityList{}
	err = c.client.Get().
		Resource("awsclusterstaticidentities").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Do(ctx).
		Into(result)
	return
}

// Watch returns a watch.Interface that watches the requested aWSClusterStaticIdentities.
func (c *aWSClusterStaticIdentities) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	opts.Watch = true
	return c.client.Get().
		Resource("awsclusterstaticidentities").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Watch(ctx)
}

// Create takes the representation of a aWSClusterStaticIdentity and creates it.  Returns the server's representation of the aWSClusterStaticIdentity, and an error, if there is any.
func (c *aWSClusterStaticIdentities) Create(ctx context.Context, aWSClusterStaticIdentity *v1beta2.AWSClusterStaticIdentity, opts v1.CreateOptions) (result *v1beta2.AWSClusterStaticIdentity, err error) {
	result = &v1beta2.AWSClusterStaticIdentity{}
	err = c.client.Post().
		Resource("awsclusterstaticidentities").
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(aWSClusterStaticIdentity).
		Do(ctx).
		Into(result)
	return
}

// Update takes the representation of a aWSClusterStaticIdentity and updates it. Returns the server's representation of the aWSClusterStaticIdentity, and an error, if there is any.
func (c *aWSClusterStaticIdentities) Update(ctx context.Context, aWSClusterStaticIdentity *v1beta2.AWSClusterStaticIdentity, opts v1.UpdateOptions) (result *v1beta2.AWSClusterStaticIdentity, err error) {
	result = &v1beta2.AWSClusterStaticIdentity{}
	err = c.client.Put().
		Resource("awsclusterstaticidentities").
		Name(aWSClusterStaticIdentity.Name).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(aWSClusterStaticIdentity).
		Do(ctx).
		Into(result)
	return
}

// Delete takes name of the aWSClusterStaticIdentity and deletes it. Returns an error if one occurs.
func (c *aWSClusterStaticIdentities) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	return c.client.Delete().
		Resource("awsclusterstaticidentities").
		Name(name).
		Body(&opts).
		Do(ctx).
		Error()
}

// DeleteCollection deletes a collection of objects.
func (c *aWSClusterStaticIdentities) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	var timeout time.Duration
	if listOpts.TimeoutSeconds != nil {
		timeout = time.Duration(*listOpts.TimeoutSeconds) * time.Second
	}
	return c.client.Delete().
		Resource("awsclusterstaticidentities").
		VersionedParams(&listOpts, scheme.ParameterCodec).
		Timeout(timeout).
		Body(&opts).
		Do(ctx).
		Error()
}

// Patch applies the patch and returns the patched aWSClusterStaticIdentity.
func (c *aWSClusterStaticIdentities) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1beta2.AWSClusterStaticIdentity, err error) {
	result = &v1beta2.AWSClusterStaticIdentity{}
	err = c.client.Patch(pt).
		Resource("awsclusterstaticidentities").
		Name(name).
		SubResource(subresources...).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(data).
		Do(ctx).
		Into(result)
	return
}
